/* 1220, Sun  9 Dec 07 (NZDT)

   owt_mem.h:  Defines for owtmon memory management

   Copyright (C) 2008-2010 by Nevil Brownlee, U Auckland | CAIDA | WAND */


/* #defines to declare variables and functions
   to allocate and manage stream_engine memory
   for struct 's_name'

   [ gcc -E to only run preprocessor
     gcc -c test.c
     gcc -o test -lpthread semaphore.o test.o ] */


/* (1) Declare global structs, usable in all .c files
       and templates for functions to work with them */

#define owt_mem_declare_globals(s_name) \
struct s_name##_space { \
   struct s_name *objects; \
   int mx_objects; \
   int complained_about_objects; \
   struct s_name##_queue free_queue; \
   }; \
\
extern struct s_name##_space s_name##_space; \
void init_##s_name##_space( \
   struct s_name##_space *s_name##_space, int n_objects); \
struct s_name *get_##s_name##_object( \
   struct s_name##_space *s_name##_space); \
void free_##s_name##_object(struct s_name *this, \
   struct s_name##_space *s_name##_space);

/* (2) Define variables and functions (matching the templates) */

#define owt_mem_declare_functions(s_name) \
struct s_name##_space s_name##_space; \
\
void init_##s_name##_space( \
      struct s_name##_space *s_name##_space, int n_objects) { \
   int j; \
   s_name##_space->mx_objects = n_objects;  /* Get object space */ \
   if ((s_name##_space->objects = (struct s_name *)calloc( \
      n_objects, sizeof(struct s_name))) == NULL)	\
      log_msg(LOG_ERR, 1, "Not enough memory for " #s_name " objects!"); \
   memset(s_name##_space->objects, 0, sizeof(struct s_name)*n_objects); \
   init_##s_name##_queue(&s_name##_space->free_queue); \
   for (j = 0; j != n_objects; ++j)  /* Initialise free queue */ \
      s_name##_push(&s_name##_space->free_queue, &s_name##_space->objects[j]); \
   s_name##_space->complained_about_objects = 0; \
   } \
\
struct s_name *get_##s_name##_object( \
      struct s_name##_space *s_name##_space) { \
   struct s_name *this; \
   s_name##_q_lock(&s_name##_space->free_queue); \
   this = s_name##_shift(&s_name##_space->free_queue); \
   if (this == NULL) { \
      if (!s_name##_space->complained_about_objects) { \
         log_msg(LOG_WARNING, 0, "No free " #s_name " objects <<<"); \
         s_name##_space->complained_about_objects = 1; \
         } \
      s_name##_q_unlock(&s_name##_space->free_queue); \
      return NULL; \
      } \
   s_name##_q_unlock(&s_name##_space->free_queue); \
   return this; \
   } \
\
void free_##s_name##_object(struct s_name *this, \
      struct s_name##_space *s_name##_space) { \
   s_name##_q_lock(&s_name##_space->free_queue); \
   s_name##_push(&s_name##_space->free_queue, this); \
   s_name##_space->complained_about_objects = 0; \
   s_name##_q_unlock(&s_name##_space->free_queue); \
   }

/* (3) Define variables within a .c file */

#define owt_mem_declare_space(s_name) \
struct s_name##_space s_name##_space;
