/* 1955, Thu 22 Apr 10 (PDT)
   1445, Wed  5 Dec 07 (NZDT)

   owt_support.c:  Support routines for owtmon

   Copyright 2007-2010, Nevil Brownlee, U Auckland | CAIDA | WAND */

#include "owt.h"

/* Define global variables (declared extern in owt.h) */

char *logname;
struct stream *extra_streams[MX_EXTRA_STREAMS+1];
int extra_stream_incr, n_extra_streams;

#if MKSTATSCOUNTS
uint32_t  /* Per-interval stats arrays for each source type .. */
//x   **pkts_seen_per_stats_interval, *pkts_seen_this_interval,
   **active_sources_per_stats_interval, *active_sources_this_interval,
   **unique_hosts_per_stats_interval, *unique_hosts_this_interval;
uint32_t stats_interval_nbr;
#endif

#if MKDESTCOUNTS
uint32_t **dest_addrs_per_source_type;
#define src_addr_bin(a)  ((ntohl(a) >> 24) & 0x000000FF)  /* 1st byte */
uint32_t (*dest_addr_bin)(uint32_t a);
#endif

struct ip_address la[MX_LOCAL_ADDRS];
int n_local_addrs;

int n_source_types, pkts_to_record, min_pkts_to_classify,
   min_pkts_for_active_source, traces_to_process;
char **other_uris;
int next_uri_nbr;

int time_rec_interval, intervals_this_sum_file;

int n_lost_stream_v4s, n_lost_stream_v6s;
uint64_t last_drops;

uint32_t mx_active_streams, mx_active_pkt_datas, mx_active_opq_entries,
   av_cl_count, n_hc_searches,  src_av_cl_count, src_n_hc_searches;
uint32_t n_not_ip,n_frags,n_too_small,n_no_local_address,
   n_v6_opaque;

uint64_t one_way_bytes, two_way_bytes,  /* Overall stats */
   one_way_pkts, two_way_pkts,
   one_way_streams, two_way_streams,
   v6_one_way_bytes, v6_two_way_bytes,
   v6_one_way_pkts, v6_two_way_pkts,
   v6_one_way_streams, v6_two_way_streams,
   not_one_way_streams;

uint32_t start_ts;  /* Seconds part of first-packet timestamp */

int n_source_types, pkts_to_record, min_pkts_to_classify,
   min_pkts_for_active_source, traces_to_process;
char **other_uris;
int next_uri_nbr;

int time_rec_interval, intervals_this_sum_file;

int n_lost_stream_v4s, n_lost_stream_v6s;
uint64_t last_drops;

uint32_t mx_active_streams, mx_active_pkt_datas,
   av_cl_count, n_hc_searches,  src_av_cl_count, src_n_hc_searches;
uint32_t n_not_ip,n_frags,n_too_small,n_no_local_address,
   n_v6_opaque;

uint64_t one_way_bytes, two_way_bytes,  /* Overall stats */
   one_way_pkts, two_way_pkts,
   one_way_streams, two_way_streams,
   not_one_way_streams;

uint32_t start_ts;  /* Seconds part of first-packet timestamp */

int snaplen;
uint32_t g_last_ts;  /* Max last_ts for all interfaces */

struct if_info if_info[MXINTERFACES];
int n_interfaces,   /* Nbr of interfaces specified */
   n_interfaces_running;

owt_queue_declare_space(opq, opq_entry);  /* Define opq itself */

struct event event_q;  /* Queue of active events, dummy first member */

pthread_mutex_t 
   log_file_mutex,     /* log_file */
   event_q_mutex,      /* Event queue */
   if_info_mutex,      /* if_info table */
   stream_data_mutex,  /* stream data (packet/byte counts) */
   n_fw_mutex,         /* n_fw_running */
   count_mutex;        /* lock for count/count_cv */

pthread_cond_t count_cv;
int count;  /* Nbr of check_timeouts() running */

int n_fw_running;  /* Nbr of flow watchers running */

Semaphore stream_empty;  /* Controls for packet-watcher input queue */

Semaphore opq_ready, opq_empty;  /* Output queue (to outer-block loop) */

#include <sys/utsname.h>
struct utsname node;  /* Info about the host we're nunning on */

char *version;

int request_shutdown;  /* True to stop stream engine */

int live_source;  /* Zero for trace files */

int my_uid, ut_uid, my_gid, ut_gid;


void quack(int agent) {
   log_msg(LOG_ERR, 0,  "***** quack(%d) *****\n", agent);
   }

void log_msg(int priority, int die, char *fmt, ...)
{
/* priority = LOG_ERR, LOG_WARNING, LOG_INFO, LOG_DEBUG
      (LOG_INFO messages aren't written to local log file)
      die = +1 to exit, 0 normally */

   char msg[300];  /* Longest log message ~ 130, 13 Mar 01 !!! */
   va_list ap;
   FILE *log_file = NULL;
   time_t t;  char *ts, ftb[32];

   va_start(ap, fmt);
   vsprintf(msg, fmt, ap);
   va_end(ap);

   if (priority != LOG_INFO) {
      mutex_lock("lms", &log_file_mutex);
      setegid(ut_gid);  seteuid(ut_uid);
#if 0
         if ((log_file = fopen(logname,"a")) == NULL) {
            fprintf(stderr,"Failed to open logfile '%s':%s\n",
               logname, strerror(errno));
            exit(321);  /* Don't try to run without log file! */
            }
#endif
         if (log_file != NULL) {
            time(&t);  ts = ctime(&t);
            strncpy(&ftb[0],  &ts[11], 9);  /* 17:31:42_ */
            strncpy(&ftb[9],  &ts[0],  4);  /* Thu_ */
            strncpy(&ftb[13], &ts[8],  3);  /* 23_  */
            strncpy(&ftb[16], &ts[4],  4);  /* Sep_ */
            strncpy(&ftb[20], &ts[20], 4);  /* 1997 */
            ftb[24] = '\0';
            fprintf(log_file,"%s (%2d): %s\n", ftb, priority, msg);
            fclose(log_file);
            }
	 seteuid(my_uid);  setegid(my_uid);
      mutex_unlock("lms", &log_file_mutex);
      }
   fprintf(stderr, "%s\n", msg);
   if (die > 0) {
      stop_meter("### Fatal error, check log file ###");
      }
   }

void uid_from_cwd(void) {
   char buf[200];  int j;
   struct passwd *pw;

   my_uid = getuid();  /* ids we started with (root for a live interface) */
   my_gid = getgid();
   ut_uid = ut_gid = 0;  /* (non-root) ids for stream_engine */
   if (getcwd(buf, sizeof(buf)) != NULL) {  /* Get username from cwd */
      if (strncmp(buf, "/home/", 6) == 0) {
         for (j = 6; buf[j] != '/'; ++j);
         buf[j] = 0;
         if ((pw = getpwnam(&buf[6])) != NULL) {  /* Look up its uid */
            ut_uid = pw->pw_uid;  ut_gid = pw->pw_gid;
	    }
         }
      }
   }

owt_queue_declare_functions(event);
owt_mem_declare_space(event);
owt_mem_declare_functions(event);

struct event *get_event(int t, int interval) {  /* Get an unused event */
   struct event *e = get_event_object(&event_space);
   if (e != NULL) {
      e->type = t;  e->interval = interval;
      return e;
      }
   else return NULL;
   }

void schedule_event(struct event *ev, uint32_t first_t) {
   struct event *eqp, *lqp;

   if (ev == NULL)
      log_msg(LOG_WARNING, 0, "Tried to schedule NULL event!");

   ev->t = first_t;
   mutex_lock("ue", &event_q_mutex);
   lqp = &event_q;  eqp = event_q.next;
   for ( ; eqp != NULL; lqp = eqp, eqp = eqp->next) {
      if (ev->t <= eqp->t) break;  /* Closest to head */
      }
   lqp->next = ev;  ev->next = eqp;
   mutex_unlock("ue", &event_q_mutex);
   }

int check_events(uint32_t now) {
   struct event *ep;
   uint32_t e_type;

   mutex_lock("cde", &event_q_mutex);
   ep = event_q.next;
   if (ep == NULL || ep->t > now) {
      mutex_unlock("cde", &event_q_mutex);
      return NO_EVENT;
      }
   event_q.next = ep->next;  /* Remove from event queue */
   mutex_unlock("cde", &event_q_mutex);
   e_type = ep->type;

   if (ep->interval != 0)
      schedule_event(ep, ep->t += ep->interval);
   else free_event_object(ep, &event_space);

   return e_type;
   }

owt_queue_declare_functions(opq_entry);
owt_mem_declare_space(opq_entry);
owt_mem_declare_functions(opq_entry);

int sp_bad(struct stream *sp) {
   int ix;
   ix = sp - stream_space.objects;
   return ix < 0 || ix >= stream_space.mx_objects;
   }

struct opq_entry *oqe_for_stream(struct stream *sp) {
   struct opq_entry *oqe;
   struct stream *esbp;
   int ix;
   if ((oqe = get_opq_entry_object(&opq_entry_space)) == NULL)
      return NULL;
   if (sp != NULL) {
      esbp = extra_streams[sp->ext_blk];
      ix = sp - esbp;
      oqe->s_id = sp->ext_blk | (ix << 3);
      }
   else oqe->s_id = -1;
   oqe->next = NULL;
   return oqe;
   }

struct stream *stream_from_oqe(struct opq_entry *oqe) {
   struct stream *esbp = extra_streams[oqe->s_id & 0x7];
   return &esbp[oqe->s_id >> 3];
   }

owt_queue_declare_functions(pkt_data);
owt_mem_declare_space(pkt_data);
owt_mem_declare_functions(pkt_data);

owt_queue2_declare_functions(stream);
owt_mem_declare_space(stream);
owt_mem_declare_functions(stream);

struct stream *get_stream(int kind)  /* Get an unused stream */
{  /* kind: 4=IPv4 or 6=IPv6 */
   struct stream *sp, *extra_stream_objects;
   int j;
   if (kind == 4 || kind == 6) {
      if (stream_space.free_queue.length != 0)
         sp = get_stream_object(&stream_space);
      else {
         if (n_extra_streams == MX_EXTRA_STREAMS) log_msg(LOG_ERR, 1,
	    "More than %d extra stream blocks needed <<<", MX_EXTRA_STREAMS);
         if ((extra_stream_objects = (struct stream *)calloc(
	       extra_stream_incr, sizeof(struct stream))) == NULL)
            log_msg(LOG_ERR, 1, "Couldn't calloc() extra stream objects!");
         n_extra_streams += 1;
         extra_streams[n_extra_streams] = extra_stream_objects;
         stream_space.mx_objects += extra_stream_incr;
         stream_q_lock(&stream_space.free_queue);  /* Lock added, 19 Apr 10 */
         for (j = 0; j != extra_stream_incr; ++j) {
	    extra_stream_objects[j].ext_blk = n_extra_streams;
	    stream_push(&stream_space.free_queue, &extra_stream_objects[j]);
	    }
         stream_q_unlock(&stream_space.free_queue);
	 sp = get_stream_object(&stream_space);
	 log_msg(LOG_WARNING, 0,
            "Extra streams (%d): mx_streams now = %d <<<<<",
	    n_extra_streams, stream_space.mx_objects);
         }
      sp->analysed = sp->src_type = 0;
      return sp;
      }
   else log_msg(LOG_ERR, 2, "Failed to get_stream(%d) <<<", kind);
   }

void free_pkt_data(struct pkt_data *pktp)
{  /* Return pkt_data to free list */
   pktp->last_op = PD_FREE;
   free_pkt_data_object(pktp, &pkt_data_space);
   }

void free_pkt_queue(struct pkt_data_queue *pq) {  /* Discard queued pkts */
   struct pkt_data *op;
   pkt_data_q_lock(pq);
   while (op = pkt_data_shift(pq))
      free_pkt_data(op);
   pkt_data_q_unlock(pq);
   }

void free_stream(struct stream *sp)  /* Return stream to free list */
{
   struct pkt_data_queue *pq;
   int way = sp->fp == 0 ? 1 : 2;
   sp->state = SS_FREE;
   if (sp->pktp != NULL) {
      log_msg(LOG_ERR, 0, "Freeing non-null sp->pktp");
      free_pkt_data(sp->pktp);
      sp->pktp = NULL;
      }
   if (sp->pktq.length != 0) {
      free_pkt_queue(&sp->pktq);
      }
   free_stream_object(sp, &stream_space);
   }

void stream_fl_check(void) {
   int j;
   struct stream *csp;
   struct pkt_data *pdp;
   struct ip_address *ipap;
   struct sd_tuple_v6 *st6p;

   printf("fl_check(): n_free_stream=%d, stream_space=%x",
      stream_space.free_queue.length, (long)stream_space.objects);
   for (j = 1, csp = stream_space.free_queue.head; csp->next != NULL; ) {
      j += 1;  csp = csp->next;
      }
   if (j == stream_space.free_queue.length) printf(": OK\n");
   else printf(": error, %d != %d\n", j, stream_space.free_queue.length);

   printf("fl_check(): n_free_pkt_data=%d, pkt_data_space=%x",
      pkt_data_space.free_queue.length, (long)pkt_data_space.objects);
   for (j = 1, pdp = pkt_data_space.free_queue.head; pdp->next != NULL; ) {
      j += 1;  pdp = pdp->next;
      }
   if (j == pkt_data_space.free_queue.length) printf(": OK\n");
   else printf(": error, %d != %d\n", j, pkt_data_space.free_queue.length);

   fflush(stdout);
   }

owt_queue_declare_functions(stream_txt)
owt_mem_declare_space(stream_txt)
owt_mem_declare_functions(stream_txt)

owt_queue_declare_functions(flow_watcher_control)
owt_mem_declare_space(flow_watcher_control)
owt_mem_declare_functions(flow_watcher_control)

void init_mutex(pthread_mutex_t *m, char *name) {
   if (pthread_mutex_init(m, pthread_mutexattr_default) == -1)
      log_msg(LOG_ERR, 6, "Couldn't init %s", name);
   }

void init_mutexes(void) {
   init_mutex(&log_file_mutex, "log_file_mutex");
   init_mutex(&event_q_mutex, "event_q_mutex");
   init_mutex(&if_info_mutex, "if_info_mutex");
   init_mutex(&stream_data_mutex, "stream_data_mutex");
   init_mutex(&n_fw_mutex, "n_fw_mutex");
   init_mutex(&count_mutex, "count_mutex");
   }

void owt_start(int mx_events, int mx_opq_entries, 
   int mx_streams, int mx_pkt_datas,
   int mx_stream_txts, int mx_flow_watcher_controls)
{
   int j;

   init_mutexes();
   init_event_space(&event_space, mx_events);
   memset(&event_q, 0, sizeof(struct event));
   event_q.type = NO_EVENT;

   init_opq_entry_space(&opq_entry_space, mx_opq_entries);
   init_opq_entry_queue(&opq);

   init_stream_space(&stream_space, mx_streams);
   extra_streams[0] = stream_space.objects;
   extra_stream_incr = mx_streams;  n_extra_streams = 0;
   init_pkt_data_space(&pkt_data_space, mx_pkt_datas);
 
   init_stream_txt_space(&stream_txt_space, mx_stream_txts);

   init_flow_watcher_control_space(
      &flow_watcher_control_space, mx_flow_watcher_controls);
   }

void owt_stop(void) {
   }


static char *strmov(char *d, char *s) {
   while (*s != '\0') *d++ = *s++;
   return d;
   }

char *v6addr_to_s(char *v6a, struct ip_address *p)
{  /* Returns pointer to next byte in v6a 
      Code from NeTraMet's nmc_pars.c */
   char buf[10];  /* RFC 2373: IPv6 Address Architecture */
   char *d = v6a;
   char *a = (char *)p->a.a;
   int j, k, st,len, stx,lenx;
   uint32_t v, a2[8];

   st = len = lenx = 0;
   for (k = j = 0; j != 16; j += 2) {
      v =  ntohs(*(uint16_t *)&a[j]);
      a2[k++] = v;          /* Build array of two-byte pairs */
      if (v == 0) ++len;
      else {
         if (len > lenx) {  /* Find longest run of zero pairs */
            stx = st;  lenx = len;
	    }
         st = k;  len = 0;
         }
      }

   if (len > lenx) {
      stx = st;  lenx = len;
      }
   if (lenx != 0 && stx == 0) {  /* Longest run at left */
      d = strmov(d, ":");  j = lenx;
      }
   else {
      sprintf(buf, "%x", a2[0]);
      d = strmov(d,buf);  j = 1;
      }
   for (; j < 8; ) {
      if (lenx != 0 && j == stx) {
         d = strmov(d,":");  j += lenx;
         }
      else {
         sprintf(buf, ":%x", a2[j]);
         d = strmov(d, buf);  ++j;
         }
      }
   if (j == stx+lenx) d = strmov(d, ":");  /* Longest run at right */
   *d = '\0';
   return d;
   }


struct owt_ht *owt_ht_create(int mx_hash_entries) {
   struct owt_ht *new_htbl = malloc(sizeof(struct owt_ht));
   init_mutex(&new_htbl->ht_lock, "owt_ht_create");
   new_htbl->table_size = mx_hash_entries;
   new_htbl->sfht = (void **)malloc(mx_hash_entries*sizeof(void *));
   if (new_htbl->sfht == NULL)
      log_msg(LOG_ERR, 7, "Not enough memory for stream hash table!");
   memset(new_htbl->sfht, 0, new_htbl->table_size*sizeof(void *));
   return new_htbl;
   }

uint32_t owt_hash(struct stream *sp) {
    /* stream hash, determines flow_watcher for every packet,
          also determines stream the packet belongs to */
   if (sp->version == 4) {
      return sp->src_addr.a.v4 ^ (4 * 97171);
      }
   else {  /* v6 stream */
      uint64_t hh = 
 	 sp->src_addr.a.o.oct0 ^ sp->src_addr.a.o.oct1;
      return ((uint32_t *)&hh)[1] ^ ((uint32_t *)&hh)[0] ^ (6 * 96953);
      }
   }

uint32_t owt_compare(void *record, void *sh_entry) {
   struct stream *sp = (struct stream *)record;
   struct stream *shte = (struct stream *)sh_entry;
   if (sp->version == 4) {
      return
	 sp->src_addr.a.v4 == shte->src_addr.a.v4 &&
         sp->version == shte->version;
      }
   else {  /* v6 stream */
      return 
         sp->src_addr.a.o.oct1 == shte->src_addr.a.o.oct1 &&
	 sp->src_addr.a.o.oct0 == shte->src_addr.a.o.oct0 &&
         sp->version == shte->version;
      }
   }

void *owt_ht_lookup(struct owt_ht *t, uint32_t hash,
      struct stream *record, int *OK_to_add) {
   struct stream **sha;
   struct stream *shte, *lshte, *sp;
   int cl;

   mutex_lock("slu", &t->ht_lock);
   sha = (struct stream **)&t->sfht[hash % t->table_size];
      /* Address of stream hash table entry */
   if ((shte = *sha) == NULL) {
      lshte = NULL;  /* Empty hash chain */
      }
   else {
      for (cl = 1; ; cl += 1) {
 	 if (owt_compare(record, shte)) break;  /* Matched */
         lshte = shte;
         if ((shte = lshte->next_hc) == (struct stream *)sha) {
            shte = NULL;  break;
            /* Loop stops with lshte -> last stream in chain */
	    }
         }
      av_cl_count += cl;  n_hc_searches += 1;
      }

   if (shte != NULL) {  /* Existing stream */
      *OK_to_add = 0;
//    if (shte == record) quack(6001);
      mutex_unlock("slu", &t->ht_lock);
      return shte;
      }
   else if (!*OK_to_add) {  /* Not in stream table */
      mutex_unlock("slu", &t->ht_lock);
      return NULL;
      }
   else {  /* Enter record in stream table */
      sp = (struct stream *)record;
//    if (shte != NULL) quack(6002);
      if (lshte == NULL) *sha = sp;  /* Add stream to hash chain */
      else lshte->next_hc = sp;
      sp->next_hc = (struct stream *)sha;
      sp->state = SS_NEW;
      //?? sp->last_report_sec = sp->ts;   //??
      mutex_unlock("slu", &t->ht_lock);
      *OK_to_add = 1;  /* We added this stream */
      return sp;
      }
   }

void *owt_ht_delete(struct owt_ht *t, void *record) {
   struct stream *sp, *np, *tp, *ltp;

   sp = (struct stream *)record;
   mutex_lock("slu", &t->ht_lock);
   np = sp->next_hc;  /* Remove stream from hash chain */
   tp = sp;  do {
      ltp = tp;
      } while ((tp = tp->next_hc) != sp);
   if (ltp == np)  /* Single flow in hash chain */
      np->next_hc = NULL;
   else ltp->next_hc = np;
   sp->next_hc = NULL;
   mutex_unlock("slu", &t->ht_lock);
   }

static uint8_t p_mask[8] = { 0x00, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE };

int addr_is_local(int ver, struct ip_address *addrp) {  /* in local_addrs[] */
   int j, nb,k, len;
   uint8_t *a = addrp->a.a;
   for (j = 0; j != n_local_addrs; ++j) {
      if (ver == la[j].ver) {
	 len = la[j].len;
         nb = len/8;  /* whole bytes */
         for (k = 0; k != nb; ++k)
            if (a[k] != la[j].a.a[k]) break;
         if (k != nb) return 0;  /* false */
         if (k*8 == len) return 1;  /* Match up to length */
         // printf("   =========== last byte match %d  %02x ^ %02x -> %d\n",
	 //    k, a[k], la[j].a.a[k], ((a[k] ^ la[j].a.a[k]) & p_mask[len%8]) == 0);
         return ((a[k] ^ la[j].a.a[k]) & p_mask[len%8]) == 0;
         }
      }   
   return 0;
   }
